* program: lb_scale.prg                creation date: 07/23/90
*                                      last modified: 07/23/90
*     Richard P. Hendricks 
*     General Electric Co., AE
*     Data Management and User Applications
*     1000 Western Ave., MD: 464x5
*     Lynn, MA  01910
*     (617) 594-9692   8*263-9692
*
* Developed under FoxPro Version 1.02

*
**
*** Demonstration  -- Start
**
*
set talk off
set console off

define window main from 1, 5 to 6, 35 title " Scale Demo "
activate window main
@ 1,0 say "To Start ... Press a key"

scale1 = "scale_one"
scale2 = "scale_two"

** Initial Scale(s)
=scale( scale1,  7, 10, "Opening Files ... Please wait", 0, 10 )
=scale( scale2, 12, 15, "Indexing Files ... Please wait", 0, 20 )
activate window main
wait

** Update Scale(s)
=scale( scale1, 10, 10, "",  3, 10 )
for i = 1 to 20
 activate window main
 wait timeout 1
 =scale( scale2, 10, 10, "", i, 50 )
endfor
activate window main
wait timeout 2
=scale( scale1, 10, 10, "",  7, 10 )
for i = 20 to 40
 activate window main
 wait timeout 1
 =scale( scale2, 10, 10, "",  i, 50 )
endfor
activate window main
wait timeout 2
=scale( scale1, 10, 10, "", 10, 10 )
for i = 40 to 50
 activate window main
 wait timeout 1
 =scale( scale2, 10, 10, "",  i, 50 )
endfor
activate window main
@ 2, 0 say "Complete..."
wait timeout 2

** Close Scales
=scale( scale1, -1, -1, "", 0, 10 )
=scale( scale2, -1, -1, "", 0, 20 )
@ 3, 0 say "Scales removed..."
wait timeout 2

deactivate window main
release window main
return && end-of-demo

*
**
*** Demonstration  -- End
**
*

function scale
parameters win_name, row, col, msg, cur_knt, max_knt
************************************************************************
* win_name - window handle. This needs to be a unique window name.
* row, col - upper left hand corner of the scale
*            (if one or both are negative, then the
*            scale will be removed) Changing the row, col will not move
*            the scales position. After the initial call, the only affect
*            that row and column have is on the closing of the window,ie,
*            set them to negative numbers.
* msg      - message to be displayed on the scale. Only required on
*            the first call to the function.
*            Example: 
*                Opening Files ... Please wait
* cur_knt  - when cur_knt is less than or equal to zero, then the scale
*            is displayed initially
*          - when the cur_knt is greater than 0 and less than equal to
*            max_knt, then the scale is updated
* max_knt  - maximum number of steps that will be shown on the scale. The
*            same value should be passed for each call to the scale function
*
*
w_len = 6
w_width = 47

if row < 0 .or. col < 0
  deactivate window &win_name
  release window &win_name
  return .t.
endif

if cur_knt <= 0
  define window &win_name from row, col to row+w_len, col+w_width;
         close double shadow
  activate window &win_name
  @ 0,0 say padc( msg, w_width )
  @ 1,2,3,w_width-4 box
  @ 4,2 say "0  10  20  30  40  50  60  70  80  90  100"
endif

if cur_knt > 0
  if cur_knt > max_knt
    cur_knt = max_knt
  endif
  activate window &win_name
  @ 2,3 say replicate( chr(219), int( (cur_knt/max_knt) * (w_width-7) ) )
endif
return .t. && end-of-function scale()

end-of-file lb_scale.prg 